#include <stdio.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    int n,m;
    scanf("%d",&t);
    for (int i=0;i<t;i++)
    {
        scanf("%d%d",&n,&m);
        long long *a=(long long*)malloc(n*sizeof(long long));
        long long *b=(long long*)malloc(m*sizeof(long long));
        for (int i=0;i<n;i++) scanf("%lld", &a[i]);
        for (int i=0;i<m;i++) scanf("%lld", &b[i]);
        sort(a,a+n);

        long long d=a[0];
        for (int i=0;i<n-1;i++) a[i]=a[i+1]-a[i];
        long long mini=a[0];
        for (int i=0;i<n-1;i++) if (a[i]<mini) mini=a[i];

        int provera=1;
        for (int i=0;i<n-1;i++) if (a[i]%mini!=0)  provera=0;
        for (int i=0;i<m;i++) if ((b[i]-d)%mini==0) provera=0;
        printf("%d\n",provera);
    }
}